﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class GameManager : MonoBehaviour {

	public AudioClip music;
	//public Canvas InGameUI;
	public Text TimerText;
	public Text RemainingText;
	public Text MoneyText;

	public float Timer;
	public float Money;

	public int RemainingLives;
	private int CurrentRemainingLives;

	private ScoreManager scoreManager;
	
	// Use this for initialization
	void Start () {

		SoundManager.instance.PlayMusic(music);

		Timer = 0;
		Money = 0;
		CurrentRemainingLives = RemainingLives;

		scoreManager = GameObject.Find("ScoreManager").GetComponent<ScoreManager>();

		//TimerText = InGameUI.GetComponent<Text>();
		
	}
	
	// Update is called once per frame
	void Update () {

		Timer += Time.deltaTime;

		TimerText.text = ((int) Timer).ToString();
		RemainingText.text = "Remaining: " + CurrentRemainingLives.ToString();
		MoneyText.text = "Cash: " + Money;
		
	}

	public void ReportUnhappyCustomer()
	{
		CurrentRemainingLives--;

		if(CurrentRemainingLives <= 0)
		{
			EndGame();
		}

	}

	public void AddMoney(float value)
	{
		Money += value;
	}

	void EndGame()
	{
		Debug.Log("You lose the game!");
		scoreManager.SetScore(Timer, Money);
		SceneManager.LoadScene("Ending");
	}
}
