﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Holder : MonoBehaviour {

	public Camera Cam;
	public float ZOrderToHold;
	private bool holding;
	private Holdable CurrentHolding;
	private Person CurrentPerson;
	Vector3 LastPosition;
	Vector3 HoldPosition;
	public LayerMask DropLayerMask;

	private ShopManager ShopManager;

	// Use this for initialization
	void Start () {
		holding = false;

		ShopManager = GameObject.Find("Manager").GetComponent<ShopManager>();
	}
	
	// Update is called once per frame
	void Update () {

		if(Input.GetMouseButton(0))
		{
			if(!holding)
			{
				RaycastHit2D hit = Physics2D.Raycast(Camera.main.ScreenToWorldPoint(Input.mousePosition), Vector2.zero);
 
				if(hit.collider != null)
				{
					CurrentHolding = hit.transform.gameObject.GetComponent<Holdable>();
					CurrentPerson = hit.transform.gameObject.GetComponent<Person>();

					if(CurrentHolding && CurrentPerson)
					{
						ShopManager.ToggleHolders();
						ShopManager.RemoveFromLine(CurrentPerson);
						CurrentPerson.ClearAttributes();
						CurrentPerson.SetBeingHold(true);
						holding = true;
					}
				}
			}
		}

		if (Input.GetMouseButtonUp(0))
		{
			if(holding)
			{
				ShopManager.ToggleHolders();
				CheckBeforeDrop();
			}
			CurrentPerson.ResetRotation();
			CurrentPerson.SetBeingHold(false);

			holding = false;
		}

		if(holding)
		{
			LastPosition = HoldPosition;
			HoldPosition = Camera.main.ScreenToWorldPoint(Input.mousePosition);
			HoldPosition.z = ZOrderToHold;

			CurrentHolding.HoldTo(HoldPosition);
			CurrentHolding.UpdateRotation(LastPosition - HoldPosition);
		}
		
	}

	void CheckBeforeDrop()
	{
		RaycastHit2D hit = Physics2D.Raycast(Camera.main.ScreenToWorldPoint(Input.mousePosition), Vector2.zero, 10f, DropLayerMask);
 
		if(hit.collider != null)
		{
			Debug.Log(hit.collider.name);
			
			LineManager lineManager = hit.transform.gameObject.GetComponent<LineManager>();

			if(lineManager)
			{
				if(lineManager.isLineFull() == false)
				{
					lineManager.OcuppyLinePlace(CurrentPerson);
					CurrentPerson.SetCurrentLineManager(lineManager);
					CurrentPerson.SetLine(lineManager.GetLineIndex());
					CurrentPerson.MoveTo(lineManager.GetPlacePosition(CurrentPerson.GetPlace()));
					CurrentPerson.SetIsLeaving(false);

					Debug.Log("Released place: " + CurrentPerson.GetPlace());
					Debug.Log("Released line: " + CurrentPerson.GetLine());
				}
				else
				{
					CurrentPerson.LeaveStore();
				}
			}
			else
			{
				Debug.Log("Deu errado");
			}
		}
	}
}
