﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class InitialLogic : MonoBehaviour {

	public AudioClip music;
	public RawImage BackgroundImg;
	public RawImage CreditsImg;

	bool ShowingCredits;

	void Start()
	{
		CreditsImg.enabled = false;
		BackgroundImg.enabled = true;
		ShowingCredits = false;

		SoundManager.instance.PlayMusic(music);
	}

	void Update()
	{
		if(Input.GetMouseButtonDown(0))
		{
			if(ShowingCredits == true)
			{
				CreditsImg.enabled = false;
				BackgroundImg.enabled = true;
				ShowingCredits = false;
			}
		}
	}

	public void Play()
	{
		SceneManager.LoadScene("main");
	}

	public void Credits()
	{
		if(ShowingCredits == false)
		{
			CreditsImg.enabled = true;
			BackgroundImg.enabled = false;
			ShowingCredits = true;
		}
	}

	public void Exit()
	{
		Application.Quit();
	}
}
