﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Product : MonoBehaviour {

	public Sprite sprite;
	public float workload;
	public float money;
	public Vector3 offset;
	public Vector3 offset_random;
	public Vector3 rotation;
	public Vector3 rotation_random;
	public int probability;

	private SpriteRenderer spriteRenderer;

	void Start()
	{
		spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
		spriteRenderer.sprite = sprite;

		transform.localPosition += new Vector3(offset.x + Random.Range(0, offset_random.x), offset.y + Random.Range(0, offset_random.y), offset.z + Random.Range(0, offset_random.z));
		transform.eulerAngles = new Vector3(rotation.x + Random.Range(0, rotation_random.x), rotation.y + Random.Range(0, rotation_random.y), rotation.z + Random.Range(0, rotation_random.z));
	}

	public float GetWorkload()
	{
		return workload;
	}

	public float GetMoney()
	{
		return money;
	}
}
